#pragma once

//#define _WIN32_WINNT 0x0501

//#define _WIN32_DCOM

#if(_WIN32_WINNT <= 0x0500)

// These two struct-size macros taken from WinNT.h. God knows why they are not included
// unless WINNT is greater than 0x0500

//
// Calculate the size of a field in a structure of type type, without
// knowing or stating the type of the field.
//
#define RTL_FIELD_SIZE(type, field) (sizeof(((type *)0)->field))

//
// Calculate the size of a structure of type type up through and
// including a field.
//
#define RTL_SIZEOF_THROUGH_FIELD(type, field) \
    (FIELD_OFFSET(type, field) + RTL_FIELD_SIZE(type, field))

#endif

#define _USE_MATH_DEFINES

#include <winsock2.h>
//#include <windows.h>
#include <commctrl.h>
#include <richedit.h>
#include <stdio.h>
#include <tchar.h>
#include <ctype.h>
#include <errno.h>
#include <fcntl.h>
#include <float.h>
#include <limits.h>
#include <cmath>
//#include <setjmp.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>
#include <direct.h>
//#include <io.h>
#include <algorithm>
#include <string>
#include <vector>
#include <map>

#include "../../Third_Party/distributions/CxImage/CxImage/ximage.h"
#include "../../Third_Party/distributions/CxImage/jpeg/jpeglib.h"
#include "../../Third_Party/distributions/CxImage/jpeg/jerror.h"

#include "../../Third_Party/distributions/lcms/include/lcms.h"

#include "viewer plugins.h"

// For dcraw:

typedef unsigned char uchar;
typedef unsigned short ushort;

// BE->LE
#define SWAPLONG(l)		((((l)&0xff)<<24)|((((l)>>8)&0xff)<<16)|((((l)>>16)&0xff)<<8)|(((l)>>24)&0xff))
#define SWAPSHORT(s)	((((s)&0xff)<<8)|(((s)>>8)&0xff))
